#include <windows.h> 

#define MAX_RECORD_LEN		1024
#define MAX_DICT_NUMBER		255
#define SAMPLE_WORDS_COUNT	150
#define SAMPLE_WORDS_COUNT_MAX	(SAMPLE_WORDS_COUNT*(CHARSET_COUNT-1))

int lang[MAX_DICT_NUMBER];
int langCount,langSum;
unsigned char* langName[MAX_DICT_NUMBER];
int longDictLen,shortDictLen,longDict,shortDict;
bool joinCharsets[256];

inline void checkWord(unsigned char* s,int s_size)
{
	if (s_size<WORD_MIN_SIZE)
		return;

	s[s_size]=0;

	int i=checkHashExactly(s,s_size,stringHash(s,s_size));

	if (i>=0)
	{
		lang[i/SAMPLE_WORDS_COUNT_MAX]++;
		langSum++;
	}

	return;
}

int WRT_detectFileType(FILE* file, int part_length, int parts)
{
	unsigned char s[1024];
	int d,i,last_c,c,flen,length;
	int s_size,shortLangSum,binCount,EOLCount,EOLCountBad,punctCount,punctCountBad,fftell;
	float max,current;
	int lastPos[256];
	int fc[MAX_RECORD_LEN],fc_max;
	int quarterByte=0;

	memset(&lang[0],0,MAX_DICT_NUMBER*sizeof(lang[0]));
	memset(value,0,sizeof(value));
	s_size=0;
	binCount=0;
	EOLCount=0;
	EOLCountBad=0;
	punctCount=0;
	punctCountBad=0;
	last_c=0;
	c=32;
	dictionary=1<<30;

	for (i=0; i<255; i++)
		lastPos[i]=0;

	for (i=0; i<MAX_RECORD_LEN; i++)
		fc[i]=0;

	fc_max=0;


	fseek(file, 0, SEEK_END );
	flen=ftell(file)-part_length;

	if (part_length*parts>flen)
	{
		parts=1;
		part_length+=flen;
		flen=0;
	}

	for (i=1; i<=parts; i++)
	{
		fseek(file, (flen/parts)*i, SEEK_SET );
		fftell=(flen/parts)*i;
		length=part_length;

		while (length>0 && c>=0)
		{
			length--;
			 
			value[c]++;

			if (last_c!=c)
			{
				d=fftell-lastPos[c];
				lastPos[c]=fftell;
				if (d<MAX_RECORD_LEN)
				{
					fc[d]++;
					if (fc[d]>fc[fc_max])
						fc_max=d;
				}
			}


			if ((c<32 || (c>=BINARY_FIRST && !joinCharsets[c])) && c!=0 && c!=9 && c!=10 && c!=13)
				binCount++;

			
			if (joinCharsets[c] || (c>='a' && c<='z') || (c<='Z' && c>='A'))
			{
				switch (c)
				{
					case 'c':
					case 'a':
					case 't':
					case 'g':
						quarterByte++;
				}

				c=TOLOWER(c);
				
				s[s_size++]=c;
				if (s_size>=sizeof(s)-1)
				{
					checkWord(s,s_size);
					s_size=0;
				}
				last_c=c;
				c=getc(file);
				fftell++;
				continue;
			}
			
			
			checkWord(s,s_size);
			s_size=0;
			
			if (c=='\r')
			{
				c=fgetc(file);
				fftell++;
			}

			if (c=='\n')
			{	
				c=fgetc(file);
				fftell++;
				c=TOLOWER(c);
				last_c=TOLOWER(last_c);
				if (last_c>='a' && last_c<='z' && c>='a' && c<='z')
					EOLCount++;
				else
					EOLCountBad++;

				last_c='\n';
			}
			else
			{
				if (PUNCTUATION_CHARS(c)) 
				{
					if ((last_c>='a' && last_c<='z') || (last_c>='A' && last_c<='Z'))
						punctCountBad++;
					else
					if (last_c>=' ')
						punctCount++;
				}
				last_c=c;
			}

			c=fgetc(file);
			fftell++;
		}
	}

	fseek(file, 0, SEEK_END );
	flen=ftell(file);

	fseek(file, 0, SEEK_SET );


	shortLangSum=0;
	for (i=0; i<langCount; i++)
		if (memcmp(SHORT_DICTNAME,langName[i],sizeof(SHORT_DICTNAME)-1)==0)
			shortLangSum+=lang[i];
	langSum-=shortLangSum;


	longDict=-1;
	shortDict=-1;

	if ((parts==1 && langSum+shortLangSum>=18) || 
		langSum+shortLangSum>part_length*parts/250) 
	{
		max=0.0;
		for (i=0; i<langCount; i++)
		{
			if (memcmp(SHORT_DICTNAME,langName[i],sizeof(SHORT_DICTNAME)-1)!=0)
			{
				current=100.0f*lang[i]/langSum;
				if (current>max)
				{
					max=current;
					longDict=i;
				}
			}
		}

		if (shortLangSum*5>langSum)
		{
			max=0.0;
			for (i=0; i<langCount; i++)
			{
				if (memcmp(SHORT_DICTNAME,langName[i],sizeof(SHORT_DICTNAME)-1)==0)
				{
					current=100.0f*lang[i]/shortLangSum;
					if (current>max)
					{
						max=current;
						shortDict=i;
					}
				}
			}
		}
	}

	if (longDict>=0)
		longDictLen=strlen((const char*)langName[longDict])-strlen(DICTNAME)-strlen(DICTNAME_EXT);
	else
		longDictLen=0;

	if (shortDict>=0)
		shortDictLen=strlen((const char*)langName[shortDict])-strlen(SHORT_DICTNAME)-strlen(DICTNAME_EXT);
	else
		shortDictLen=0;


	if (longDictLen<=0 && shortDictLen<=0)
		TURN_OFF(OPTION_USE_DICTIONARY);

	if (binCount>part_length*parts/50) // 1024
	{
		if (!forceWordSurroroundModeling)
			TURN_OFF(OPTION_WORD_SURROROUNDING_MODELING);
		if (!forceNormalTextFilter)
			TURN_OFF(OPTION_NORMAL_TEXT_FILTER);
	}


	if (punctCount*3>punctCountBad*2)
		if (!forceWordSurroroundModeling)
			TURN_OFF(OPTION_WORD_SURROROUNDING_MODELING);


	if (EOLCount<256 || EOLCount>5120 || EOLCountBad/EOLCount>3)
		if (!forceEOLcoding)
			TURN_OFF(OPTION_EOL_CODING);


	if (!IF_OPTION(OPTION_USE_DICTIONARY))
	{
		if (!forceWordSurroroundModeling)
			TURN_OFF(OPTION_WORD_SURROROUNDING_MODELING);
	}

	if (part_length*parts>quarterByte+1)
		TURN_OFF(OPTION_DNA_QUARTER_BYTE)

//	printf("EOLCount=%d+%d(%d) binCount=%d/%d(%d) punctCount=%d/%d(%d) langSum=%d/%d(%d)\n",EOLCount,EOLCountBad,IF_OPTION(OPTION_EOL_CODING),binCount,part_length*parts/50,!IF_OPTION(OPTION_NORMAL_TEXT_FILTER),punctCount,punctCountBad,IF_OPTION(OPTION_WORD_SURROROUNDING_MODELING),langSum,part_length*parts/100,IF_OPTION(OPTION_USE_DICTIONARY));
//	printf("OPTION_DNA_QUARTER_BYTE part_length*parts=%d quarterByte=%d\n",part_length*parts,quarterByte);

	if (fc[fc_max]*fc_max>65536 && !IF_OPTION(OPTION_NORMAL_TEXT_FILTER))
		return fc_max;

	return 0;
}


inline void addWord(unsigned char* mem,int& i,int& sizeFullDict)
{
	dictlen[sizeFullDict]=i;
	dict[sizeFullDict]=mem;
	int j=stringHash(mem,i);

	if (word_hash[j]!=0)
	{
		if (dictlen[word_hash[j]]!=dictlen[sizeFullDict] || 
			sizeFullDict/SAMPLE_WORDS_COUNT_MAX!=word_hash[j]/SAMPLE_WORDS_COUNT_MAX ||
			memcmp((const char*)dict[word_hash[j]],(const char*)dict[sizeFullDict],i)!=0)
			word_hash[j]=-1;
	}
	else
		word_hash[j]=sizeFullDict;

	sizeFullDict++;
}

bool readDicts(char* pattern,char* dictPath,int dictPathLen)
{
	FILE* file;
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	unsigned char* word;
	unsigned char* mem;
	bool nonlatin;
	int c,i,len,sizeFullDict=0;

	memset(joinCharsets,0,sizeof(joinCharsets));
	memset(&word_hash[0],0,HASH_TABLE_SIZE*sizeof(word_hash[0]));
	dict=(unsigned char**)calloc(sizeof(unsigned char*)*(SAMPLE_WORDS_COUNT_MAX*MAX_DICT_NUMBER),1);
	dictlen=(unsigned char*)calloc(sizeof(unsigned char)*(SAMPLE_WORDS_COUNT_MAX*MAX_DICT_NUMBER),1);
	dictmem=(unsigned char*)calloc(SAMPLE_WORDS_COUNT_MAX*10*MAX_DICT_NUMBER,1);

	langSum=0;
	langCount=0;
	sizeDict=0;
	mem=dictmem;
	dictPath[dictPathLen]=0;
	strcat(dictPath,pattern);
	hFind = FindFirstFile(dictPath, &FindFileData);

//	printf("%s\n",dictPath);

	if (hFind != INVALID_HANDLE_VALUE) 
	do
	{
		dictPath[dictPathLen]=0;
		strcat(dictPath,FindFileData.cFileName);

	//	printf("%s\n",dictPath);

		file=fopen((const char*)dictPath,"rb");
		if (file==NULL)
			continue;
		
		i=strlen(FindFileData.cFileName);


		toLower((unsigned char*)FindFileData.cFileName,i);
		langName[langCount]=(unsigned char*)malloc(i+1);
		memcpy(langName[langCount],(const char*)FindFileData.cFileName,i+1);

		memset(lowerSet,0,sizeof(lowerSet));
		memset(lowerSetRev,0,sizeof(lowerSetRev));

		do c=getc(file); while (c>=32); if (c==13) c=getc(file); 

		for (i=0; i<CHARSET_COUNT; i++)
		{
			do  c=getc(file); while (c>=32); if (c==13) c=getc(file); 
			freeLower[i]=1;
			loadCharset(file,freeLower[i],lowerSet[i],lowerSetRev[i],joinCharsets);
		}


		sizeFullDict=sizeDict;

		while (!feof(file))
		{
			word=mem;
			nonlatin=false;
			do
			{
				c=getc(file);
				word[0]=c;
				if (lowerSet[0][c]>0)
					nonlatin=true;
				word++;
			}
			while (c>32);
			if (c==EOF)
				break;

			if (c==13)
				c=getc(file); // skip CR+LF or LF

			word[-1]=0;
			len=word-mem-1;


			addWord(mem,len,sizeFullDict);
			word=mem+(len/4+1)*4;

			if (nonlatin)
			{
				for (i=1; i<CHARSET_COUNT-1; i++)
				{
					if (freeLower[i]>1)
					{
						for (c=0; c<len; c++)
						{
							if (lowerSet[0][mem[c]]>0)
								word[c]=lowerSetRev[i][lowerSet[0][mem[c]]];
							else
								word[c]=mem[c];
						}

						addWord(word,len,sizeFullDict);
						word+=(len/4+1)*4;
					}
				}
			}

			mem=word;

			sizeDict++;

			if (sizeDict%SAMPLE_WORDS_COUNT==0)
				break;
		}

		if (sizeDict%SAMPLE_WORDS_COUNT_MAX!=0)
			sizeDict=((sizeDict/SAMPLE_WORDS_COUNT_MAX)+1)*SAMPLE_WORDS_COUNT_MAX;

		langCount++;

		fclose(file);
	}
	while (FindNextFile(hFind,&FindFileData));

	FindClose(hFind);


	return true;
}

void freeDicts()
{
	if (dict)
		free(dict);
	if (dictlen)
		free(dictlen);
	if (dictmem)
		free(dictmem);

}

void freeNames()
{
	for (int i=0; i<langCount; i++)
		free(langName[i]);
}

#ifdef WIN32
int getSourcePath(char* buf, int buf_size)
{
	int pos;

	pos=GetModuleFileName(NULL,buf,buf_size);

	for (int i=pos-1; i>=0; i--)
		if (buf[i]=='\\')
		{
			buf[i+1]=0;
			pos=i+1;
			break;
		}

	return pos;
}
#endif
